/*
Serial interface example
 By GllBhh for Fab Academy 2023
 Modified by Essi Huusko (added LED button) Fab Academy 2023
 */


//import liblaries
//to install g4p go to "Sketch/Import Library/Manage Libraries"
//search for g4p and install it
//to install GUI builder go to "Tools/Manage Tools"
//search for "g4p GUI builder" and install it
import g4p_controls.*;
import processing.serial.*;

//create a new object 'serial'
Serial serial;

//serial port speed. Must be the same in Arduino
int speed = 9600;

void setup() {
  //window size(Width, Height), px
  size(720, 480);
  //print list of available com ports
  //print(Serial.list()); 
  //call for createGUI() from gui.pde
  createGUI();
}

/*from Arduino to PC
 0,1 - Button press
 */


/*From PC to Arduino
 0,(0..1) - LED on pin 0, where 0 - LED off, 1 - LED on
 */

void draw() {
  //fill background
  background(50);
  //draw a circle in the middle of the window
  circle(width/2, height/2, 100);
  //if serial exists
  if (serial != null) {
    //if there is something in the serial buffer
    if (serial.available() > 0) {
      //read data until newline
      String str = serial.readStringUntil('\n');
      //remove '\n' from the end of the string
      str = str.trim();   
      //split string into array of strings using ',' as separator
      String data[] = str.split(",");
      //prepare a switch key converting string data[0] to int
      int key = int(data[0]);
      switch(key) {
      case 0:
        //change fill to random color on button press
        fill(random(0,255),random(0,255),random(0,255));
        break;
      case 1:
        break;
      }
    }
  }
}
